#!/usr/bin/env python
# vim: set fileencoding=utf-8 :

###############################################################################
#                                                                             #
# Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/           #
# Contact: beat.support@idiap.ch                                              #
#                                                                             #
# This file is part of the beat.web module of the BEAT platform.              #
#                                                                             #
# Commercial License Usage                                                    #
# Licensees holding valid commercial BEAT licenses may use this file in       #
# accordance with the terms contained in a written agreement between you      #
# and Idiap. For further information contact tto@idiap.ch                     #
#                                                                             #
# Alternatively, this file may be used under the terms of the GNU Affero      #
# Public License version 3 as published by the Free Software and appearing    #
# in the file LICENSE.AGPL included in the packaging of this file.            #
# The BEAT platform is distributed in the hope that it will be useful, but    #
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  #
# or FITNESS FOR A PARTICULAR PURPOSE.                                        #
#                                                                             #
# You should have received a copy of the GNU Affero Public License along      #
# with the BEAT platform. If not, see http://www.gnu.org/licenses/.           #
#                                                                             #
###############################################################################

from django.conf.urls import url

import api

urlpatterns = [

        url(r'^$',
            api.ListAlgorithmsView.as_view(),
            name='all',
            ),

        url(r'^check_name/$',
            api.CheckAlgorithmNameView.as_view(),
            name='check_name',
            ),

        url(r'^diff/(?P<author1>\w+)/(?P<name1>[-\w]+)/(?P<version1>\d+)/(?P<author2>\w+)/(?P<name2>[-\w]+)/(?P<version2>\d+)/$',
            api.DiffAlgorithmView.as_view(),
            name='diff',
            ),

        url(r'^(?P<author_name>\w+)/(?P<object_name>[-\w]+)/(?P<version>\d+)/share/$',
            api.ShareAlgorithmView.as_view(),
            name='share',
            ),

        url(r'^(?P<author_name>\w+)/$',
            api.ListCreateAlgorithmsView.as_view(),
            name='list_create',
            ),

        url(r'^(?P<author_name>\w+)/(?P<object_name>[-\w]+)/(?P<version>\d+)/$',
            api.RetrieveUpdateDestroyAlgorithmsView.as_view(),
            name='object',
            ),

        url(r'^(?P<author_name>\w+)/(?P<object_name>[-\w]+)/$',
            api.RetrieveUpdateDestroyAlgorithmsView.as_view(),
            name='object',
            ),

        url(r'^(?P<author_name>\w+)/(?P<object_name>[-\w]+)/(?P<version>\d+)/binary/$',
            api.binary,
            name='binary',
            ),

        url(r'^(?P<author_name>\w+)/(?P<object_name>[-\w]+)/binary/$',
            api.binary,
            name='binary',
            ),

        ]
