# -*- coding: utf-8 -*-
# Generated by Django 1.9.11 on 2016-11-23 12:18
from __future__ import unicode_literals

from django.db import migrations, models
import django.db.models.deletion


def add_default_language(apps, schema_editor):
    Environment = apps.get_model("backend", "Environment")
    EnvironmentLanguage = apps.get_model("backend", "EnvironmentLanguage")

    for env in Environment.objects.all():
        lang = EnvironmentLanguage(language='P', environment=env)
        lang.save()


class Migration(migrations.Migration):

    dependencies = [
        ('backend', '0003_remove_result_syserr'),
    ]

    operations = [
        migrations.CreateModel(
            name='EnvironmentLanguage',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('language', models.CharField(choices=[(b'U', b'Unknown'), (b'C', b'Cxx'), (b'M', b'Matlab'), (b'P', b'Python'), (b'R', b'R')], default=b'P', max_length=1)),
                ('environment', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='languages', to='backend.Environment')),
            ],
        ),
        migrations.RunPython(add_default_language, migrations.RunPython.noop),
    ]
