#!/usr/bin/env python
# vim: set fileencoding=utf-8 :

###############################################################################
#                                                                             #
# Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/           #
# Contact: beat.support@idiap.ch                                              #
#                                                                             #
# This file is part of the beat.web module of the BEAT platform.              #
#                                                                             #
# Commercial License Usage                                                    #
# Licensees holding valid commercial BEAT licenses may use this file in       #
# accordance with the terms contained in a written agreement between you      #
# and Idiap. For further information contact tto@idiap.ch                     #
#                                                                             #
# Alternatively, this file may be used under the terms of the GNU Affero      #
# Public License version 3 as published by the Free Software and appearing    #
# in the file LICENSE.AGPL included in the packaging of this file.            #
# The BEAT platform is distributed in the hope that it will be useful, but    #
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  #
# or FITNESS FOR A PARTICULAR PURPOSE.                                        #
#                                                                             #
# You should have received a copy of the GNU Affero Public License along      #
# with the BEAT platform. If not, see http://www.gnu.org/licenses/.           #
#                                                                             #
###############################################################################

"""
Exceptions used by beat.web. All internal and beat.web-specific errors
should extend BeatWebError class.
"""
from __future__ import unicode_literals


class BeatWebError(Exception):
    def __init__(self, message=None):
        """
        The `message` argument can be a single error or a list of errors
        """
        super(BeatWebError, self).__init__()
        self.__message = message

    @property
    def errors(self):
        return self.__message

class NotUserNorTeam(BeatWebError):
    pass

class BaseCreationError(BeatWebError):
    pass

class ShareError(BeatWebError):
    pass

class ContributionCreationError(BaseCreationError):
    pass
