/*
 * Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/
 * Contact: beat.support@idiap.ch
 * 
 * This file is part of the beat.web module of the BEAT platform.
 * 
 * Commercial License Usage
 * Licensees holding valid commercial BEAT licenses may use this file in
 * accordance with the terms contained in a written agreement between you
 * and Idiap. For further information contact tto@idiap.ch
 * 
 * Alternatively, this file may be used under the terms of the GNU Affero
 * Public License version 3 as published by the Free Software and appearing
 * in the file LICENSE.AGPL included in the packaging of this file.
 * The BEAT platform is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * You should have received a copy of the GNU Affero Public License along
 * with the BEAT platform. If not, see http://www.gnu.org/licenses/.
*/
/* beat.databases.utils.js

   Databases-related utility functions
*/


// Declaration of our namespaces
if (beat === undefined)
    var beat = {}

if (beat.databases === undefined)
    beat.databases = {}

if (beat.databases.utils === undefined)
    beat.databases.utils = {}


//----------------------------------------------------------------------------------------
// Retrieve the list of database templates
//
// The callback is expected to have the following signature: callback(data), where 'data'
// is an object containing the result.
//
// In case of error, 'data' is a string describing the error.
//----------------------------------------------------------------------------------------
beat.databases.utils.getTemplates = function(platform_url, callback)
{
    // Use the web API
    $.get(platform_url + '/api/v1/databases/templates/', function(data)
        {
            // Invoke the callback
            callback(data);
        }
    ).fail(function(jqXHR) {
        if (jqXHR.status == 403)
            callback(null, 'Unauthorized access');
        else
            callback(null, jqXHR.statusText);
    });
}
