#!/usr/bin/env python
# vim: set fileencoding=utf-8 :

###############################################################################
#                                                                             #
# Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/           #
# Contact: beat.support@idiap.ch                                              #
#                                                                             #
# This file is part of the beat.web module of the BEAT platform.              #
#                                                                             #
# Commercial License Usage                                                    #
# Licensees holding valid commercial BEAT licenses may use this file in       #
# accordance with the terms contained in a written agreement between you      #
# and Idiap. For further information contact tto@idiap.ch                     #
#                                                                             #
# Alternatively, this file may be used under the terms of the GNU Affero      #
# Public License version 3 as published by the Free Software and appearing    #
# in the file LICENSE.AGPL included in the packaging of this file.            #
# The BEAT platform is distributed in the hope that it will be useful, but    #
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  #
# or FITNESS FOR A PARTICULAR PURPOSE.                                        #
#                                                                             #
# You should have received a copy of the GNU Affero Public License along      #
# with the BEAT platform. If not, see http://www.gnu.org/licenses/.           #
#                                                                             #
###############################################################################


from __future__ import unicode_literals

from django.db import migrations, models

class Migration(migrations.Migration):

    dependencies = [
        ('backend', '0002_scheduler_addons'),
        ('databases', '0002_scheduler_addons'),
        ('experiments', '0003_scheduler_addons_2'),
    ]

    operations = [
        migrations.AlterUniqueTogether(
            name='result',
            unique_together=set([('cache', 'name')]),
        ),
        migrations.RemoveField(
            model_name='result',
            name='block',
        ),
        migrations.CreateModel(
            name='BlockInput',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False,
                  auto_created=True, primary_key=True)),
                ('channel', models.CharField(default=b'',
                  help_text=b'Synchronization channel within the toolchain',
                  max_length=200, blank=True)),
                ('block', models.ForeignKey(related_name='inputs',
                  to='experiments.Block', null=True)),
                ('cache', models.ForeignKey(related_name='inputs',
                  to='experiments.CachedFile', null=True)),
                ('database', models.ForeignKey(related_name='blocks',
                  to='databases.DatabaseSetOutput', null=True)),
            ],
        ),
        migrations.AddField(
            model_name='block',
            name='channel',
            field=models.CharField(default=b'',
            help_text=b'Synchronization channel within the toolchain',
            max_length=200, blank=True),
        ),
        migrations.AddField(
            model_name='block',
            name='command',
            field=models.TextField(null=True, blank=True),
        ),
        migrations.AddField(
            model_name='block',
            name='dependencies',
            field=models.ManyToManyField(related_name='dependents',
              to='experiments.Block', blank=True),
        ),
        migrations.AlterField(
            model_name='block',
            name='environment',
            field=models.ForeignKey(related_name='blocks',
              on_delete=models.deletion.SET_NULL, to='backend.Environment',
              null=True),
        ),
        migrations.AddField(
            model_name='block',
            name='queue',
            field=models.ForeignKey(related_name='blocks',
              on_delete=models.deletion.SET_NULL, to='backend.Queue',
              null=True),
        ),
        migrations.AddField(
            model_name='block',
            name='required_slots',
            field=models.PositiveIntegerField(default=1),
        ),
        migrations.AlterField(
            model_name='block',
            name='status',
            field=models.CharField(default=b'N', max_length=1,
              choices=[
                (b'N', b'Not cached'),
                (b'P', b'Processing'),
                (b'C', b'Cached'),
                (b'F', b'Failed'),
                (b'S', b'Skipped'),
                (b'L', b'Cancelled'),
                ]
              ),
        ),
        migrations.AlterUniqueTogether(
            name='block',
            unique_together=set([('experiment', 'name')]),
        ),
        migrations.AlterField(
            model_name='cachedfile',
            name='blocks',
            field=models.ManyToManyField(related_name='outputs',
              to='experiments.Block', blank=True),
        ),
    ]
