/*
 * Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/
 * Contact: beat.support@idiap.ch
 *
 * This file is part of the beat.web module of the BEAT platform.
 *
 * Commercial License Usage
 * Licensees holding valid commercial BEAT licenses may use this file in
 * accordance with the terms contained in a written agreement between you
 * and Idiap. For further information contact tto@idiap.ch
 *
 * Alternatively, this file may be used under the terms of the GNU Affero
 * Public License version 3 as published by the Free Software and appearing
 * in the file LICENSE.AGPL included in the packaging of this file.
 * The BEAT platform is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * You should have received a copy of the GNU Affero Public License along
 * with the BEAT platform. If not, see http://www.gnu.org/licenses/.
 */

//Directive used to handle table settings click
angular.module('reportApp').directive("aliasexperiment", function($compile){
	return {
		link:function(scope, element, attrs){
			let alias_name = scope.$parent.$parent.$parent.$parent.report_experiments_alias[scope.name];
			createAlias(scope.name, alias_name);

			element.bind("click", function(){
				let input_element = document.getElementById("input_"+scope.name);
				let icon_element = document.getElementById("icon_"+scope.name);
				let button_element = document.getElementById("button_alias_"+scope.name);
				if(! $(input_element).hasClass("input-disabled")){
					if ($(input_element).val()){
						$(input_element).addClass("input-disabled");
						$(input_element).attr("disabled", true);
						$(icon_element).removeClass("fa-unlock");
						$(icon_element).addClass("fa-lock");
						$(button_element).addClass("setalias");
						let experiment_name = attrs.id.split("button_alias_")[1];
						let alias_name = $(input_element).val();
						$(input_element).val(alias_name);
						createAlias(experiment_name, alias_name);
					}
					else{
						alert("Alias for experiment" + scope.name + " can't be empty!");
					}
				}
				else{
					$(input_element).removeClass("input-disabled");
					$(input_element).attr("disabled", false);
					$(icon_element).removeClass("fa-lock");
					$(icon_element).addClass("fa-unlock");
					$(button_element).removeClass("setalias");

				}
			});

			function createAlias(experiment_name, alias_name){
				scope.report_experiments_alias[experiment_name] = alias_name;
				scope.$parent.$parent.$parent.$parent.report_experiments_alias[experiment_name] = alias_name;

				if(!scope.$$phase){
					//$digest or $apply
					let parent_scope = scope.$parent.$parent.$parent.$parent;
					let table_details = parent_scope.tables_details;

					for(let i = 0; i < parent_scope.report.orderedcontent.length; i++){
						let element = document.getElementById(parent_scope.report.orderedcontent[i]);

						$(element).remove();

						let id_content = parent_scope.report.orderedcontent[i];
						let type = id_content.split("_")[0];
						parent_scope.$parent.$broadcast("addSavedElement", id_content, type);
					}
				}
			}
		}
	};
});

