/*
 * Copyright (c) 2016 Idiap Research Institute, http://www.idiap.ch/
 * Contact: beat.support@idiap.ch
 * 
 * This file is part of the beat.web module of the BEAT platform.
 * 
 * Commercial License Usage
 * Licensees holding valid commercial BEAT licenses may use this file in
 * accordance with the terms contained in a written agreement between you
 * and Idiap. For further information contact tto@idiap.ch
 * 
 * Alternatively, this file may be used under the terms of the GNU Affero
 * Public License version 3 as published by the Free Software and appearing
 * in the file LICENSE.AGPL included in the packaging of this file.
 * The BEAT platform is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * You should have received a copy of the GNU Affero Public License along
 * with the BEAT platform. If not, see http://www.gnu.org/licenses/.
*/
/* beat.ui.save_as.js

   Implementation of the 'Save as' dialog
*/


// Declaration of our namespaces
if (beat === undefined)
    var beat = {}

if (beat.ui === undefined)
    beat.ui = {}

if (beat.ui.save_as === undefined)
    beat.ui.save_as = {}



beat.ui.save_as.show = function(dialog_id, callback, original_name, unusable_names)
{
    if (original_name == undefined)
        original_name = '';

    if (unusable_names == undefined)
        unusable_names = [];


    // Create the dialog
    $('#' + dialog_id).dialog({
        autoOpen: false,
        resizable: false,
        width: Math.min($(window).width() * 0.6, 700),
        position: { my: "center", at: "center", of: window },
        modal: true,
        closeOnEscape: true,
        buttons: [
            {
                id: 'button-' + dialog_id + '-save',
                text: 'Save',
                click: function() {
                    var name = $('#' + dialog_id + ' input.name')[0].value.trim();

                    if (name.length == 0)
                    {
                        alert("You can't enter an empty name!");
                        return;
                    }

                    if (name == original_name)
                    {
                        alert("The new name is the same as the previous one!");
                        return;
                    }

                    if (unusable_names.indexOf(name) >= 0)
                    {
                        alert("The new name is already used!");
                        return;
                    }

                    callback(name);
                }
            },
            {
                id: 'button-' + dialog_id + '-cancel',
                text: 'Cancel',
                click: function() {
                    $(this).dialog("close");
                }
            }
        ]
    });


    // Initialise the dialog content
    $('#' + dialog_id + ' input.name')[0].value = original_name;


    // Display the dialog
    $('#' + dialog_id).dialog("open");
}
